## f3d 1.2.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
include(CMakeDependentOption)

project(f3d
  VERSION "1.2.1"
  DESCRIPTION "F3D - A fast and minimalist 3D viewer"
  LANGUAGES C CXX)

string(TIMESTAMP F3D_BUILD_DATE "%Y-%m-%d %H:%M:%S")

# CMake variables
option(BUILD_TESTING "Build the tests" OFF)
cmake_dependent_option(F3D_ENABLE_LONG_TIMEOUT_TESTS "Enable long timeout tests" OFF "BUILD_TESTING" ON)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build type" FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release")
endif()

# VTK dependency
find_package(VTK 9.0 REQUIRED
  COMPONENTS
    FiltersGeneral
    FiltersGeometry
    ImagingCore
    ImagingHybrid
    InteractionStyle
    InteractionWidgets
    IOCityGML
    IOGeometry
    IOImage
    IOImport
    IOParallel
    IOPLY
    IOXML
    RenderingAnnotation
    RenderingCore
    RenderingLabel
    RenderingOpenGL2
    RenderingVolumeOpenGL2
    jsoncpp
    opengl
  OPTIONAL_COMPONENTS
    IOExodus
    RenderingRayTracing)

if(${VTK_VERSION} VERSION_LESS 9.0)
  message(FATAL_ERROR "VTK >= 9.0 is REQUIRED")
endif()

option(BUILD_SHARED_LIBS "Build f3d with shared libraries" ON)

# Modules
option(F3D_MODULE_RAYTRACING "Raytracing module" OFF)
option(F3D_MODULE_EXODUS "ExodusII module" ON)
option(F3D_MODULE_OCCT "OpenCASCADE module (STEP and IGES files)" OFF)
option(F3D_MODULE_ASSIMP "Assimp module (FBX, OFF, DAE anf DXF files)" OFF)

set(F3D_VTK_MODULES
  VTK::CommonSystem
  VTK::FiltersGeneral
  VTK::FiltersGeometry
  VTK::ImagingCore
  VTK::ImagingHybrid
  VTK::InteractionStyle
  VTK::InteractionWidgets
  VTK::IOCityGML
  VTK::IOGeometry
  VTK::IOImage
  VTK::IOImport
  VTK::IOParallel
  VTK::IOPLY
  VTK::IOXML
  VTK::RenderingAnnotation
  VTK::RenderingCore
  VTK::RenderingLabel
  VTK::RenderingOpenGL2
  VTK::RenderingVolumeOpenGL2
  VTK::jsoncpp
  VTK::opengl
)

if(F3D_MODULE_RAYTRACING)
  if(TARGET VTK::RenderingRayTracing)
    message(STATUS "VTK RayTracing enabled")
    set(F3D_VTK_MODULES ${F3D_VTK_MODULES} VTK::RenderingRayTracing)
  else()
    message(WARNING "F3D_MODULE_RAYTRACING option is enabled but VTK::RenderingRayTracing is not found")
    set(F3D_MODULE_RAYTRACING OFF)
  endif()
endif()

if(F3D_MODULE_EXODUS)
  if(TARGET VTK::IOExodus)
    message(STATUS "Module: VTK ExodusII found")
    set(F3D_VTK_MODULES ${F3D_VTK_MODULES} VTK::IOExodus)
  else()
    message(WARNING "F3D_MODULE_EXODUS option is enabled but VTK::IOExodus is not found")
    set(F3D_MODULE_EXODUS OFF)
  endif()
endif()

set(F3D_MODULE_OCCT_XCAF 0)
if(F3D_MODULE_OCCT)
  find_package(OpenCASCADE REQUIRED)
  if(OpenCASCADE_FOUND)
    set(F3D_OCCT_VERSION "${OpenCASCADE_VERSION}")
    message(STATUS "Module: OpenCASCADE ${F3D_OCCT_VERSION} found")
    if((TARGET "TKXDESTEP") AND (TARGET "TKXDEIGES"))
      set(F3D_MODULE_OCCT_XCAF 1)
    else()
      message(WARNING "Module: OpenCASCADE: TKXDESTEP and TKXDEIGES are not found. Parts color and name are not supported.")
    endif()
    if((NOT TARGET "TKSTEP") AND (NOT TARGET "TKIGES") AND (NOT TARGET "TKMesh"))
      message(FATAL_ERROR "Module: OpenCASCADE does not contain required modules")
    endif()
  endif()
endif()

if(F3D_MODULE_ASSIMP)
  find_package(assimp 5.0 REQUIRED)
  if(assimp_FOUND)
    set(F3D_ASSIMP_VERSION "${assimp_VERSION}")
    message(STATUS "Module: assimp ${F3D_ASSIMP_VERSION} found")
    if("${F3D_ASSIMP_VERSION}" VERSION_GREATER_EQUAL "5.1.0")
      message(WARNING "Module: assimp: Animations are not working with assimp 5.1.0 and newer, use assimp 5.0.X for animation support with assimp formats.")
    endif()
    if("${F3D_ASSIMP_VERSION}" VERSION_LESS "5.1.0")
      message(WARNING "Module: assimp: Embedded texture are only working with assimp 5.1.X and newer.")
    endif()
  endif()
endif()

option(F3D_GENERATE_MAN "Generate and install a man entry for f3d using help2man" OFF)
mark_as_advanced(F3D_GENERATE_MAN)

# Windows Shell Extension DLL
if(WIN32)
  option(BUILD_WINDOWS_SHELL_THUMBNAILS_EXTENSION "Build the Windows Shell Extension to produce thumbnails" ON)
endif()

# Build f3d
include(GNUInstallDirs)
add_subdirectory(src)

# testing
if(BUILD_TESTING)
  include(cmake/testing.cmake)
endif()

# installation
option(F3D_INSTALL_DEFAULT_CONFIGURATION_FILE "Install a default configuration file" OFF)
mark_as_advanced(F3D_INSTALL_DEFAULT_CONFIGURATION_FILE)
if(UNIX AND NOT APPLE)
  cmake_dependent_option(F3D_INSTALL_DEFAULT_CONFIGURATION_FILE_IN_PREFIX "Install the default configuration at the prefix root instead of system wide" OFF
    "F3D_INSTALL_DEFAULT_CONFIGURATION_FILE" OFF)
  mark_as_advanced(F3D_INSTALL_DEFAULT_CONFIGURATION_FILE_IN_PREFIX)
endif()

if(UNIX AND NOT APPLE)
  option(F3D_INSTALL_THUMBNAILER_FILES "Install thumbnailer files" OFF)
  mark_as_advanced(F3D_INSTALL_THUMBNAILER_FILES)

  option(F3D_INSTALL_MIME_TYPES_FILE "Install mime types files" OFF)
  mark_as_advanced(F3D_INSTALL_MIME_TYPES_FILE)
endif()

include(cmake/installing.cmake)

# packaging
include(cmake/packaging.cmake)

=== src/CMakeLists.txt ===
# Generate F3DIcon.h
add_executable(embed embed.cxx)
target_link_libraries(embed PUBLIC VTK::IOImage)

# On Windows, add VTK IOImage library to PATH
# It is required to run `embed` with `add_custom_command`
# Other systems supports RPATH so it is not required
if(WIN32)
  get_target_property(_confs VTK::IOImage IMPORTED_CONFIGURATIONS)
  foreach(_conf ${_confs})
    get_target_property(_runtime_path VTK::IOImage IMPORTED_LOCATION_${_conf})
    get_filename_component(_runtime_dir ${_runtime_path} DIRECTORY)
    list(APPEND CMAKE_MSVCIDE_RUN_PATH "${_runtime_dir}")
  endforeach()
endif()

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/F3DIcon.h
  COMMAND $<TARGET_FILE:embed>
    "${CMAKE_CURRENT_SOURCE_DIR}/../resources/logo32.png"
    "${CMAKE_CURRENT_BINARY_DIR}/F3DIcon.h"
  DEPENDS embed)

cmake_dependent_option(F3D_MACOS_BUNDLE "Build a macOS bundle application" ON "APPLE" OFF)
cmake_dependent_option(F3D_WINDOWS_GUI "Build a non-console Win32 application" ON "WIN32" OFF)

set(LIB_PLATFORM_SPECIFIC_FILES "")
set(EXEC_PLATFORM_SPECIFIC_FILES "")
if(WIN32)
  set(EXEC_PLATFORM_SPECIFIC_FILES "${CMAKE_SOURCE_DIR}/resources/f3d.rc")
  if(F3D_WINDOWS_GUI)
    set(LIB_PLATFORM_SPECIFIC_FILES "${CMAKE_CURRENT_SOURCE_DIR}/vtkF3DWin32OutputWindow.cxx")
  endif()
endif()
if(APPLE)
  set(LIB_PLATFORM_SPECIFIC_FILES "${CMAKE_CURRENT_SOURCE_DIR}/F3DNSDelegate.mm")
endif()

set(MODULES_SPECIFIC_SOURCE_FILES "")
set(MODULES_SPECIFIC_INCLUDE_DIRS "")
set(MODULES_SPECIFIC_LIBRARIES "")

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/Config.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/Config.h"
  @ONLY)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/Config.cxx.in"
  "${CMAKE_CURRENT_BINARY_DIR}/Config.cxx"
  @ONLY)

# Readers declaration
macro(declare_f3d_reader reader)
  list(APPEND F3D_READER_FILES "readers/${reader}.h")
  set(F3D_READER_INCLUDES_CODE
    "${F3D_READER_INCLUDES_CODE}#include \"${reader}.h\"\n")
  set(F3D_READER_INSTANCES_CODE
    "${F3D_READER_INSTANCES_CODE}  ${reader} InstanceOf${reader};\n")
  set(F3D_READER_REGISTER_CODE
    "${F3D_READER_REGISTER_CODE}    F3DReaderFactory::Register(&InstanceOf${reader});\n")
  set(F3D_READER_UNREGISTER_CODE
    "${F3D_READER_UNREGISTER_CODE}    F3DReaderFactory::Unregister(&InstanceOf${reader});\n")
endmacro()

declare_f3d_reader(F3D3DSReader)
declare_f3d_reader(F3DCityGMLReader)
declare_f3d_reader(F3DDICOMReader)
declare_f3d_reader(F3DGLTFReader)
declare_f3d_reader(F3DMetaImageReader)
declare_f3d_reader(F3DNrrdReader)
declare_f3d_reader(F3DOBJReader)
declare_f3d_reader(F3DPLYReader)
declare_f3d_reader(F3DPTSReader)
declare_f3d_reader(F3DSTLReader)
declare_f3d_reader(F3DTIFFReader)
declare_f3d_reader(F3DVRMLReader)
declare_f3d_reader(F3DVTKLegacyReader)
declare_f3d_reader(F3DVTKXMLReader)

if(F3D_MODULE_OCCT)
  set(MODULES_SPECIFIC_SOURCE_FILES ${MODULES_SPECIFIC_SOURCE_FILES} "${CMAKE_CURRENT_SOURCE_DIR}/vtkF3DOCCTReader.cxx")
  set(MODULES_SPECIFIC_INCLUDE_DIRS ${MODULES_SPECIFIC_INCLUDE_DIRS} ${OpenCASCADE_INCLUDE_DIR})
  # Note: OpenCASCADE does not declare the libs in the correct dependency order.
  # This could be an issue on Linux when linking with static libraries.
  # See .github/workflows/ci.yml for a scripted fix 
  set(MODULES_SPECIFIC_LIBRARIES ${MODULES_SPECIFIC_LIBRARIES} ${OpenCASCADE_LIBRARIES})
  
  declare_f3d_reader(F3DOpenCascadeReader)
endif()

if(F3D_MODULE_ASSIMP)
  set(MODULES_SPECIFIC_SOURCE_FILES ${MODULES_SPECIFIC_SOURCE_FILES} "${CMAKE_CURRENT_SOURCE_DIR}/vtkF3DAssimpImporter.cxx")
  set(MODULES_SPECIFIC_LIBRARIES ${MODULES_SPECIFIC_LIBRARIES} assimp::assimp)

  # Note: Assimp CMake module file does not declare Debug target properties, just map it to Release properties
  get_target_property(F3D_ASSIMP_DEBUG_VAR assimp::assimp IMPORTED_IMPLIB_RELEASE)
  if(NOT F3D_ASSIMP_DEBUG_VAR)
    set_target_properties(assimp::assimp PROPERTIES MAP_IMPORTED_CONFIG_DEBUG Release)
  endif()

  declare_f3d_reader(F3DAssimpReader)
endif()

if(F3D_MODULE_EXODUS)
  declare_f3d_reader(F3DExodusIIReader)
endif()

# Generate the code of the F3DReaderInstantiator class
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/F3DReaderInstantiator.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/F3DReaderInstantiator.h"
  @ONLY)

list(LENGTH F3D_READER_FILES F3D_NB_READERS)
message(STATUS "${F3D_NB_READERS} readers found.")

# configure_win32_exts and run it to create the NSIS install scripts
# for registering/unregistering available file extensions

if(WIN32)
  add_executable(configure_win32_exts
    configure_win32_exts.cxx
    readers/F3DReader.cxx
    readers/F3DReaderFactory.cxx
    "${CMAKE_CURRENT_BINARY_DIR}/F3DReaderInstantiator.h")

  target_compile_definitions(configure_win32_exts PUBLIC "-DF3D_NO_VTK")

  target_include_directories(configure_win32_exts PUBLIC
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/readers)

  add_custom_command(TARGET configure_win32_exts POST_BUILD
    COMMAND $<TARGET_FILE:configure_win32_exts>
      "${CMAKE_BINARY_DIR}/NSIS.RegisterCommands.nsh"
      "${CMAKE_BINARY_DIR}/NSIS.UnregisterCommands.nsh"
      "${CMAKE_BINARY_DIR}/F3DShellExtension.h"
    DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/F3DReaderInstantiator.h")
endif()

# configure_linux_mime_types and run it to create the a dynamic mime_type
# list for registering/unregistering available mime types in .desktop
# and .thumbnailer file

if(UNIX AND NOT APPLE)
  add_executable(configure_linux_mime_types
    configure_linux_mime_types.cxx
    readers/F3DReader.cxx
    readers/F3DReaderFactory.cxx
    "${CMAKE_CURRENT_BINARY_DIR}/F3DReaderInstantiator.h")

  target_compile_definitions(configure_linux_mime_types PUBLIC "-DF3D_NO_VTK")

  target_include_directories(configure_linux_mime_types PUBLIC
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/readers)

  add_custom_command(TARGET configure_linux_mime_types POST_BUILD
    COMMAND $<TARGET_FILE:configure_linux_mime_types>
      "${CMAKE_BINARY_DIR}/mime_types"
    DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/F3DReaderInstantiator.h")
endif()

# libf3d

set(F3D_SOURCE_FILES
  vtkF3DConsoleOutputWindow.cxx
  vtkF3DGenericImporter.cxx
  vtkF3DInteractorEventRecorder.cxx
  vtkF3DInteractorStyle.cxx
  vtkF3DMetaReader.cxx
  vtkF3DObjectFactory.cxx
  vtkF3DOpenGLGridMapper.cxx
  vtkF3DPolyDataMapper.cxx
  vtkF3DPostProcessFilter.cxx
  vtkF3DRenderPass.cxx
  vtkF3DRenderer.cxx
  vtkF3DRendererWithColoring.cxx
  F3DAnimationManager.cxx
  F3DLoader.cxx
  F3DLog.cxx
  F3DOffscreenRender.cxx
  F3DOptions.cxx
  readers/F3DReader.cxx
  readers/F3DReaderFactory.cxx
  ${CMAKE_CURRENT_BINARY_DIR}/Config.cxx
  ${MODULES_SPECIFIC_SOURCE_FILES}
  )

set(F3D_HEADER_FILES
  vtkF3DConsoleOutputWindow.h
  vtkF3DGenericImporter.h
  vtkF3DInteractorEventRecorder.h
  vtkF3DInteractorStyle.h
  vtkF3DMetaReader.h
  vtkF3DObjectFactory.h
  vtkF3DOpenGLGridMapper.h
  vtkF3DPolyDataMapper.h
  vtkF3DPostProcessFilter.h
  vtkF3DRenderPass.h
  vtkF3DRenderer.h
  vtkF3DRendererWithColoring.h
  F3DAnimationManager.h
  F3DLoader.h
  F3DLog.h
  F3DOffscreenRender.cxx
  F3DOptions.cxx
  readers/F3DReader.h
  readers/F3DReaderFactory.h
  ${CMAKE_CURRENT_BINARY_DIR}/F3DIcon.h
  ${CMAKE_CURRENT_BINARY_DIR}/F3DReaderInstantiator.h
  )

# Force static library when creating a macOS bundle
set(F3D_LIBRARY_TYPE "")
if(F3D_MACOS_BUNDLE)
  set(F3D_LIBRARY_TYPE "STATIC")
endif()

add_library(libf3d ${F3D_LIBRARY_TYPE}
  ${F3D_SOURCE_FILES}
  ${F3D_HEADER_FILES}
  ${F3D_READER_FILES}
  ${LIB_PLATFORM_SPECIFIC_FILES}
  )

target_include_directories(libf3d PUBLIC
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/readers
  ${CMAKE_CURRENT_BINARY_DIR}
  ${MODULES_SPECIFIC_INCLUDE_DIRS}
  )

set_target_properties(libf3d PROPERTIES
  ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib"
  RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
  WINDOWS_EXPORT_ALL_SYMBOLS ON
  PREFIX ""
  )

vtk_module_autoinit(TARGETS libf3d MODULES ${F3D_VTK_MODULES})

target_link_libraries(libf3d PUBLIC ${F3D_VTK_MODULES} ${MODULES_SPECIFIC_LIBRARIES})

set(F3D_STRICT_BUILD OFF CACHE BOOL "Use strict warnings and errors flags for building F3D")
mark_as_advanced(F3D_STRICT_BUILD)
if(F3D_STRICT_BUILD)
  if(MSVC)
    # Warning C4275 is essentially noise, disabling it to silent an issue with jsoncpp library
    target_compile_options(libf3d PUBLIC /W4 /WX /wd4275)
  else()
    target_compile_options(libf3d PUBLIC -Wall -Wextra -Werror)
  endif()
endif()

# Create man
if(F3D_GENERATE_MAN)
  find_program(HELP2MAN help2man)
  find_program(GZIP gzip)
  if (HELP2MAN AND GZIP)
    set(MAN_OUTPUT_FILE ${CMAKE_BINARY_DIR}/f3d.1)
    add_custom_command(
      OUTPUT ${MAN_OUTPUT_FILE}
      COMMAND ${HELP2MAN} $<TARGET_FILE:f3d> -N > ${MAN_OUTPUT_FILE}
      COMMAND ${GZIP} -f ${MAN_OUTPUT_FILE}
      DEPENDS f3d)
    add_custom_target(man ALL DEPENDS ${MAN_OUTPUT_FILE})
  else (HELP2MAN)
    message(WARNING "help2man or gzip not found, cannot create man entry")
  endif()
endif()

# coverage
cmake_dependent_option(F3D_COVERAGE "Emit coverage files" OFF "UNIX" OFF)
if(F3D_COVERAGE)
  target_compile_options(libf3d PUBLIC -g -O0 --coverage)
  target_link_options(libf3d PUBLIC --coverage)
endif()

# f3d

add_executable(f3d main.cxx ${EXEC_PLATFORM_SPECIFIC_FILES})
target_link_libraries(f3d PUBLIC libf3d)
set_target_properties(f3d PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
if (APPLE)
  set_target_properties(f3d PROPERTIES INSTALL_RPATH @loader_path/../lib)
elseif (UNIX)
  set_target_properties(f3d PROPERTIES INSTALL_RPATH $ORIGIN/../lib)
endif ()

if(F3D_STRICT_BUILD)
  if(MSVC)
    # Warning C4275 is essentially noise, disabling it to silent an issue with jsoncpp library
    target_compile_options(f3d PUBLIC /W4 /WX /wd4275)
  else()
    target_compile_options(f3d PUBLIC -Wall -Wextra -Werror)
  endif()
endif()

# MacOS Bundle app
if(F3D_MACOS_BUNDLE)
  set_target_properties(f3d PROPERTIES MACOSX_BUNDLE TRUE)

  # Add default configuration
  if(F3D_INSTALL_DEFAULT_CONFIGURATION_FILE)
    set(f3d_CONFIG ${CMAKE_SOURCE_DIR}/resources/config.json)
    set_source_files_properties(${f3d_CONFIG} PROPERTIES
      MACOSX_PACKAGE_LOCATION "Resources")
    target_sources(f3d PRIVATE ${f3d_CONFIG})
  endif()

  # Add logo icon
  set(MACOSX_BUNDLE_ICON_FILE logo.icns)
  set(f3d_ICON ${CMAKE_SOURCE_DIR}/resources/logo.icns)
  set_source_files_properties(${f3d_ICON} PROPERTIES
    MACOSX_PACKAGE_LOCATION "Resources")
  target_sources(f3d PRIVATE ${f3d_ICON})
  configure_file("${CMAKE_SOURCE_DIR}/resources/BundleInfo.plist.in"
    "${CMAKE_CURRENT_BINARY_DIR}/BundleInfo.plist")
  set_target_properties(f3d PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_BINARY_DIR}/BundleInfo.plist")
endif()

# Windows executable without console
if(WIN32)
  if(F3D_WINDOWS_GUI)
    set_target_properties(f3d PROPERTIES WIN32_EXECUTABLE TRUE)
  else()
    # force usage of wWinMainCRTStartup in console mode for Unicode support
    target_link_options(f3d PUBLIC "/ENTRY:wWinMainCRTStartup")
  endif()
endif()

if(BUILD_WINDOWS_SHELL_THUMBNAILS_EXTENSION)
  add_subdirectory(winshellext)
endif()

=== src/winshellext/CMakeLists.txt ===
set(F3D_WINDOWS_THUMBNAIL_TIMEOUT 8000 CACHE STRING "Windows thumbnail creation timeout in milliseconds")

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/F3DThumbnailConfig.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/F3DThumbnailConfig.h"
  @ONLY)

add_library(F3DShellExtension SHARED
  "${CMAKE_CURRENT_BINARY_DIR}/F3DThumbnailConfig.h"
  F3DShellExtension.cxx
  F3DShellExtensionClassFactory.h
  F3DThumbnailProvider.h
  F3DThumbnailProvider.cxx
  RegistryHelpers.h
  F3DShellExtension.def)

target_compile_definitions(F3DShellExtension PUBLIC UNICODE)

target_include_directories(F3DShellExtension PUBLIC ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR})

target_link_libraries(F3DShellExtension PUBLIC libf3d PRIVATE pathcch shlwapi windowscodecs)

set_target_properties(F3DShellExtension PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

=== debian/changelog ===
f3d (1.2.1+dfsg-2) unstable; urgency=medium

  * Source only upload for migration to testing
  * Update metainfo copyright
  * Bump standard version to 4.6.0.1

 -- Francois Mazen <francois@mzf.fr>  Sun, 20 Feb 2022 16:49:12 +0100

f3d (1.2.1+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #985993)

 -- Francois Mazen <francois@mzf.fr>  Sat, 27 Mar 2021 13:08:02 +0100

=== debian/control ===
Source: f3d
Section: graphics
Priority: optional
Maintainer: Francois Mazen <francois@mzf.fr>
Build-Depends: debhelper-compat (= 13),
               cmake (>=3.1),
               libvtk9-dev,
               help2man
Standards-Version: 4.6.0.1
Homepage: https://f3d-app.github.io/f3d/
Vcs-Browser: https://salsa.debian.org/debian/f3d
Vcs-Git: https://salsa.debian.org/debian/f3d.git
Rules-Requires-Root: no

Package: f3d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: fast and minimalist 3D viewer
 F3D supports many file formats, from digital content to scientific
 datasets (including glTF, stl, ply, obj), can show animations, has
 a lot of rendering options including real time physically based
 rendering and Monte Carlo pathtracing.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_TESTING:BOOL=OFF \
	-DBUILD_SHARED_LIBS=OFF \
	-DF3D_GENERATE_MAN=ON

override_dh_auto_install:
	dh_auto_install
	rm debian/f3d/usr/share/doc/f3d/LICENSE

=== debian/tests/control ===
Test-Command: f3d --version
Depends: f3d
Restrictions: superficial

Test-Command: f3d --help
Depends: f3d
Restrictions: superficial

Tests: check-cube-vtp
Depends: f3d, xvfb, xauth

## f3d 1.3.1%2Bdfsg

=== .github/test_sdk/CMakeLists.txt ===
project(test_sdk)

cmake_minimum_required(VERSION 3.2)

find_package(f3d REQUIRED)

# Check correctness of variables returned by f3dConfig.cmake
function(check_variable_defined f3d_var)
  if(NOT DEFINED ${f3d_var})
    message(FATAL_ERROR "${f3d_var} is not defined")
  endif()
  message(STATUS "${f3d_var} is set to ${${f3d_var}}")
endfunction()

check_variable_defined(f3d_MODULE_EXTERNAL_RENDERING)
check_variable_defined(f3d_MODULE_RAYTRACING)
check_variable_defined(f3d_MODULE_EXODUS)
check_variable_defined(f3d_MODULE_OCCT)
check_variable_defined(f3d_MODULE_ASSIMP)
check_variable_defined(f3d_MODULE_ALEMBIC)
check_variable_defined(f3d_PYTHON_BINDINGS)

add_executable(test_sdk main.cxx)
target_link_libraries(test_sdk f3d::libf3d)

# make sure the libf3d API is compatible with C++11
set_target_properties(test_sdk PROPERTIES CXX_STANDARD 11)

=== library/VTKExtensions/Readers/CMakeLists.txt ===
# This macro generates the reader header from the F3DReaderBoilerPlate.h.in template file
# It also adds the code in the F3DReaderInstanciator.h.in file
macro(declare_f3d_reader)
  cmake_parse_arguments(F3D_READER "HAS_CUSTOM_CODE" "NAME;VTK_IMPORTER;VTK_READER;DESCRIPTION" "EXTENSIONS;MIMETYPES" ${ARGN})

  if(F3D_READER_HAS_CUSTOM_CODE)
    set(F3D_READER_CUSTOM_CODE 1)
  else()
    set(F3D_READER_CUSTOM_CODE 0)
  endif()

  list(APPEND F3D_READER_FILES "F3D${F3D_READER_NAME}Reader.h")
  set(F3D_READER_INCLUDES_CODE
    "${F3D_READER_INCLUDES_CODE}#include \"F3D${F3D_READER_NAME}Reader.h\"\n")
  set(F3D_READER_INSTANCES_CODE
    "${F3D_READER_INSTANCES_CODE}  F3D${F3D_READER_NAME}Reader InstanceOf${F3D_READER_NAME}Reader;\n")
  set(F3D_READER_REGISTER_CODE
    "${F3D_READER_REGISTER_CODE}    F3DReaderFactory::Register(&InstanceOf${F3D_READER_NAME}Reader);\n")
  set(F3D_READER_UNREGISTER_CODE
    "${F3D_READER_UNREGISTER_CODE}    F3DReaderFactory::Unregister(&InstanceOf${F3D_READER_NAME}Reader);\n")

  list(APPEND F3D_MIME_TYPES "${F3D_READER_MIMETYPES}")
  list(APPEND F3D_EXTENSIONS "${F3D_READER_EXTENSIONS}")

  if(WIN32)
    # used for the NSIS file association during installation (see packaging.cmake)
    set(F3D_FILE_ASSOCIATION_READER "${F3D_READER_EXTENSIONS}")
    list(TRANSFORM F3D_FILE_ASSOCIATION_READER PREPEND "'.")
    list(TRANSFORM F3D_FILE_ASSOCIATION_READER APPEND "' '${F3D_READER_DESCRIPTION}'")
    list(APPEND F3D_FILE_ASSOCIATION_LIST "${F3D_FILE_ASSOCIATION_READER}")
  endif()

  list(TRANSFORM F3D_READER_EXTENSIONS PREPEND "\".")
  list(TRANSFORM F3D_READER_EXTENSIONS APPEND "\"")
  list(JOIN F3D_READER_EXTENSIONS ", " F3D_READER_EXTENSIONS)

  list(TRANSFORM F3D_READER_MIMETYPES PREPEND "\"")
  list(TRANSFORM F3D_READER_MIMETYPES APPEND "\"")
  list(JOIN F3D_READER_MIMETYPES ", " F3D_READER_MIMETYPES)

  if(F3D_READER_VTK_IMPORTER)
    set(F3D_READER_HAS_SCENE_READER 1)
  else()
    set(F3D_READER_HAS_SCENE_READER 0)
  endif()

  if(F3D_READER_VTK_READER)
    set(F3D_READER_HAS_GEOMETRY_READER 1)
  else()
    set(F3D_READER_HAS_GEOMETRY_READER 0)
  endif()

  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/F3DReaderBoilerPlate.h.in"
    "${CMAKE_CURRENT_BINARY_DIR}/F3D${F3D_READER_NAME}Reader.h")
endmacro()

set(F3D_READER_INCLUDES_CODE "")
set(F3D_READER_INSTANCES_CODE "")
set(F3D_READER_REGISTER_CODE "")
set(F3D_READER_UNREGISTER_CODE "")

declare_f3d_reader(
  NAME 3DS
  EXTENSIONS 3ds
  MIMETYPES application/vnd.3ds
  VTK_IMPORTER vtk3DSImporter
  DESCRIPTION "3DS files reader"
)

declare_f3d_reader(
  NAME CityGML
  EXTENSIONS gml
  MIMETYPES application/gml+xml
  VTK_READER vtkCityGMLReader
  DESCRIPTION "CityGML files reader"
)

declare_f3d_reader(
  NAME DICOM
  EXTENSIONS dcm
  MIMETYPES application/dicom
  VTK_READER vtkDICOMImageReader
  DESCRIPTION "DICOM images files reader"
)

declare_f3d_reader(
  NAME GLTF
  EXTENSIONS gltf glb
  MIMETYPES model/gltf-binary model/gltf+json
  VTK_READER vtkGLTFReader
  VTK_IMPORTER vtkGLTFImporter
  DESCRIPTION "glTF files reader"
  HAS_CUSTOM_CODE
)

declare_f3d_reader(
  NAME MetaImage
  EXTENSIONS mha mhd
  MIMETYPES application/vnd.mhd
  VTK_READER vtkMetaImageReader
  DESCRIPTION "MetaImage files reader"
)

declare_f3d_reader(
  NAME Nrrd
  EXTENSIONS nrrd nhdr
  MIMETYPES application/vnd.nrrd
  VTK_READER vtkNrrdReader
  DESCRIPTION "Nrrd files reader"
)

declare_f3d_reader(
  NAME OBJ
  EXTENSIONS obj
  MIMETYPES model/obj
  VTK_READER vtkOBJReader
  VTK_IMPORTER vtkOBJImporter
  DESCRIPTION "OBJ files reader"
  HAS_CUSTOM_CODE
)

declare_f3d_reader(
  NAME PLYReader
  EXTENSIONS ply
  MIMETYPES application/vnd.ply
  VTK_READER vtkPLYReader
  DESCRIPTION "PLY files reader"
)

declare_f3d_reader(
  NAME PTS
  EXTENSIONS pts
  MIMETYPES application/vnd.pts
  VTK_READER vtkPTSReader
  DESCRIPTION "PTS files reader"
)

declare_f3d_reader(
  NAME STL
  EXTENSIONS stl
  MIMETYPES model/stl
  VTK_READER vtkSTLReader
  DESCRIPTION "STL files reader"
  HAS_CUSTOM_CODE
)

declare_f3d_reader(
  NAME TIFF
  EXTENSIONS tiff tif
  MIMETYPES application/x-tgif
  VTK_READER vtkTIFFReader
  DESCRIPTION "TIFF files reader"
)

declare_f3d_reader(
  NAME VRMLReader
  EXTENSIONS wrl vmrl
  MIMETYPES model/vrml
  VTK_IMPORTER vtkVRMLImporter
  DESCRIPTION "VRML files reader"
)

declare_f3d_reader(
  NAME VTKLegacy
  EXTENSIONS vtk
  MIMETYPES application/vnd.vtk
  VTK_READER vtkPDataSetReader
  DESCRIPTION "VTK Legacy files reader"
)

declare_f3d_reader(
  NAME VTKXML
  EXTENSIONS vtp vtu vtr vti vts vtm
  MIMETYPES application/vnd.vtp application/vnd.vtu application/vnd.vtr application/vnd.vti application/vnd.vts application/vnd.vtm
  VTK_READER vtkXMLGenericDataObjectReader
  DESCRIPTION "VTK XML files reader"
)

if(F3D_MODULE_OCCT)
  declare_f3d_reader(
    NAME OCCT
    EXTENSIONS stp step igs iges
    MIMETYPES model/iges application/vnd.step
    VTK_READER vtkF3DOCCTReader
    DESCRIPTION "OpenCascade files reader"
    HAS_CUSTOM_CODE
  )
endif()

if(F3D_MODULE_ASSIMP)
  declare_f3d_reader(
    NAME Assimp
    EXTENSIONS fbx dae dxf off
    MIMETYPES application/vnd.fbx application/vnd.dae image/vnd.dxf application/vnd.off
    VTK_IMPORTER vtkF3DAssimpImporter
    DESCRIPTION "Assimp files reader"
  )
endif()

if(F3D_MODULE_ALEMBIC)
  declare_f3d_reader(
    NAME Alembic
    EXTENSIONS abc
    MIMETYPES application/vnd.abc
    VTK_IMPORTER vtkF3DAlembicImporter
    DESCRIPTION "Alembic files reader"
  )
endif()

if(F3D_MODULE_EXODUS)
  declare_f3d_reader(
    NAME ExodusII
    EXTENSIONS exo ex2 e
    MIMETYPES application/vnd.exodus
    VTK_READER vtkExodusIIReader
    DESCRIPTION "ExodusII files reader"
    HAS_CUSTOM_CODE
  )
endif()

# Generate the code of the F3DReaderInstantiator class
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/F3DReaderInstantiator.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/F3DReaderInstantiator.h"
  @ONLY)

unset(F3D_SUPPORTED_MIME_TYPES CACHE)
unset(F3D_SUPPORTED_EXTENSIONS CACHE)

set(F3D_SUPPORTED_MIME_TYPES "${F3D_MIME_TYPES}" CACHE INTERNAL "Supported mime-type list" FORCE)
set(F3D_SUPPORTED_EXTENSIONS "${F3D_EXTENSIONS}" CACHE INTERNAL "Supported extension list" FORCE)

if(WIN32)
  unset(F3D_FILE_ASSOCIATION_NSIS CACHE)
  set(F3D_FILE_ASSOCIATION_NSIS "${F3D_FILE_ASSOCIATION_LIST}" CACHE INTERNAL "File association list used by NSIS" FORCE)
endif()

list(LENGTH F3D_READER_FILES F3D_NB_READERS)
message(STATUS "${F3D_NB_READERS} readers found.")
message(STATUS "Supported extensions: ${F3D_SUPPORTED_EXTENSIONS}")

set(MODULES_SPECIFIC_INCLUDE_DIRS "")
set(MODULES_SPECIFIC_LIBRARIES "")

set(classes
  vtkF3DGenericImporter
  vtkF3DPostProcessFilter
  vtkF3DMetaReader
  F3DReader
  F3DReaderFactory
  )

if(F3D_MODULE_ASSIMP)
  list(APPEND classes vtkF3DAssimpImporter)

  # Note: Assimp CMake module file does not declare Debug target properties, just map it to Release properties
  get_target_property(F3D_ASSIMP_DEBUG_VAR assimp::assimp IMPORTED_IMPLIB_RELEASE)
  if(NOT F3D_ASSIMP_DEBUG_VAR)
    set_target_properties(assimp::assimp PROPERTIES MAP_IMPORTED_CONFIG_DEBUG Release)
  endif()
endif()

if(F3D_MODULE_OCCT)
  list(APPEND classes vtkF3DOCCTReader)
  # Note: OpenCASCADE does not declare the libs in the correct dependency order.
  # This could be an issue on Linux when linking with static libraries.
  # See .github/workflows/ci.yml for a scripted fix
endif()

if(F3D_MODULE_ALEMBIC)
  list(APPEND classes vtkF3DAlembicImporter)
endif()

vtk_module_add_module(f3d::VTKExtensionsReaders
  FORCE_STATIC
  CLASSES ${classes})

if(F3D_MODULE_OCCT)
  vtk_module_include(f3d::VTKExtensionsReaders
    PRIVATE
      $<BUILD_INTERFACE:${OpenCASCADE_INCLUDE_DIR}>)

  vtk_module_link(f3d::VTKExtensionsReaders
    PRIVATE
      ${OpenCASCADE_LIBRARIES})
endif()

=== library/VTKExtensions/Applicative/Testing/CMakeLists.txt ===
set(test_sources
  TestF3DObjectFactory.cxx
  )

if(WIN32 AND F3D_WINDOWS_GUI)
  list(APPEND test_sources TestF3DWinGuiObjectFactory.cxx)
endif()

if(VTK_VERSION VERSION_LESS_EQUAL 9.1.0)
  cmake_policy(SET CMP0115 OLD)
endif()

vtk_add_test_cxx(VTKExtensionsApplicativeTests tests
  NO_DATA NO_VALID NO_OUTPUT
  ${test_sources}
  ${CMAKE_SOURCE_DIR}/testing/ ${CMAKE_BINARY_DIR}/Testing/Temporary/)
vtk_test_cxx_executable(VTKExtensionsApplicativeTests tests)
